Subject: Bug#1495: x2goclient resumes existing session with wrong X-Server options

From: Maarten Boekhold <[email-masked]>
Date: Wed, 9 Sep 2020 11:55:10 +0400

Package: x2goclient
Version: 4.1.2.2

Windows 10, x2goclient 4.1.2.2

When resuming a "paused" x2Go session, x2goclient is using the wrong
X-Server settings.

I have configured my x2goclient with the following
settings for X.Org Server settings:

**X.Org Server settings**
[X] use custom X-Server
Executable: C:/Program Files (x86)/x2goclient/VcXsrv/vcxsrv.exe
[ ] start X-Server on X2Go Client start

Window mode: -screen 0 %wx%h -notrayicon -clipboard -keyhook \
     -nowinkill -nopn -silent-dup-error
Fullscreen mode: -fullscreen -notrayicon -clipboard -keyhook \
     -nowinkill -nopn -silent-dup-error
Single application: -multiwindow -notrayicon -clipboard \
     -keyhook -nowinkill -nopn -silent-dup-error
Whole display: -nodecoration -notrayicon -clipboard -keyhook \
     -nopn -silent-dup-error -screen 0 @

My x2goclient session is configured as:

**Session preferences: Input/Output**
[ ] Fullscreen
[ ] Custom     Width (greyed out 3696) Height (greyed out 2160)
[X] Use whole display [ ] Maximum available     Display: 2

When I start a new x2Go session, it correctly runs the X-Server with the
"Whole display" command (as per Windows Task Manager):

"C:\Program Files (x86)\x2goclient\VcXsrv\vcxsrv.exe" \
     -nodecoration -notrayicon -clipboard -keyhook -nowinkill \
     -nopn -silent-dup-error screen 0 @2 :0

But if I then "pause" this session and reconnect, x2goclient uses the
"Window mode" command line options instead:

"C:\Program Files (x86)\x2goclient\VcXsrv\vcxsrv.exe" \
     -screen 3696x2160 -notrayicon -clipboard -keyhook \
     -nowinkill -nopn -silent-dup-error :0

I suspect this has something to do with the
code around line 4442 in onmainwindow.cpp, but I've not been able to
figure out the exact details yet.

Maarten